#include "CUnit/Basic.h"
#include "main.h"

void MWO_UTC_000_000(void)
{
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	variable_Data.d_value = 0;
	variable_Data.c_value = 1;

	input_manager(3);

	CU_ASSERT_EQUAL(variable_Data.c_value, 0);
}

void MWO_UTC_000_001(void)
{
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	variable_Data.d_value = 0;
	variable_Data.c_value = 0;

	input_manager(3);

	CU_ASSERT_EQUAL(variable_Data.c_value, 1);	
}

void MWO_UTC_001_000(void)
{
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	variable_Data.c_value = 0;
	variable_Data.d_value = 5;

	input_manager(4);

	CU_ASSERT_EQUAL(variable_Data.d_value, 0);	
}


void MWO_UTC_001_001(void)
{
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	variable_Data.c_value = 1;

	input_manager(4);

	CU_ASSERT_EQUAL(button_Data.b_D, 0);	
}

void MWO_UTC_002_000(void)
{
	variable_Data.f_value = 0;
	variable_Data.e_value = 0;
	variable_Data.time = 10;

	input_manager(5);

	CU_ASSERT_EQUAL(variable_Data.e_value, 1);
}

void MWO_UTC_002_001(void)
{
	variable_Data.f_value = 0;
	variable_Data.e_value = 0;
	variable_Data.temp = 30;

	input_manager(5);

	CU_ASSERT_EQUAL(variable_Data.e_value, 1);
}

void MWO_UTC_002_002(void)
{
	variable_Data.f_value = 0;
	variable_Data.e_value = 1;

	input_manager(5);

	CU_ASSERT_EQUAL(variable_Data.e_value, 0);
}

void MWO_UTC_002_003(void)
{
	variable_Data.f_value = 1;

	input_manager(5);

	CU_ASSERT_EQUAL(button_Data.b_E, 0);
}

void MWO_UTC_003_000(void)
{
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;

	input_manager(6);

	CU_ASSERT_EQUAL(variable_Data.f_value, 1);
	CU_ASSERT_EQUAL(button_Data.b_F, 0);
}

void MWO_UTC_003_001(void)
{
	variable_Data.e_value = 0;
	variable_Data.f_value = 1;

	input_manager(6);

	CU_ASSERT_EQUAL(variable_Data.f_value, 0);
	CU_ASSERT_EQUAL(button_Data.b_F, 0);
}

void MWO_UTC_004_000(void)
{
	light_on();

	CU_ASSERT_EQUAL(variable_Data.light, 1);
}

void MWO_UTC_005_000(void)
{
	light_off();

	CU_ASSERT_EQUAL(variable_Data.light,0);
	
}

void MWO_UTC_006_000(void)
{
	beep_sound();

	CU_ASSERT_EQUAL(variable_Data.check,3);
	CU_ASSERT_EQUAL(variable_Data.sound,0);
}

void MWO_UTC_007_000(void)
{
	button_Data.b_A = 1;
	variable_Data.time = 0;

	time_setting();
	
	CU_ASSERT_EQUAL(variable_Data.time,10);
}

void MWO_UTC_007_001(void)
{
	button_Data.b_A = 1;
	variable_Data.time = 590;

	time_setting();
	
	CU_ASSERT_EQUAL(variable_Data.time,600);
}

void MWO_UTC_007_002(void)
{
	button_Data.b_A = 1;
	variable_Data.time = 600;

	time_setting();
	
	CU_ASSERT_EQUAL(variable_Data.time,10);
}

void MWO_UTC_008_000(void)
{
	button_Data.b_A = 0;
	button_Data.b_B = 1;
	variable_Data.time = 0;

	time_setting();
	
	CU_ASSERT_EQUAL(variable_Data.time,30);
}

void MWO_UTC_008_001(void)
{
	button_Data.b_A = 0;
	button_Data.b_B = 1;
	variable_Data.time = 570;

	time_setting();
	
	CU_ASSERT_EQUAL(variable_Data.time,600);
}

void MWO_UTC_008_002(void)
{
	button_Data.b_A = 0;
	button_Data.b_B = 1;
	variable_Data.time = 580;

	time_setting();
	
	CU_ASSERT_EQUAL(variable_Data.time,600);
}

void MWO_UTC_008_003(void)
{
	button_Data.b_A = 0;
	button_Data.b_B = 1;
	variable_Data.time = 590;

	time_setting();
	
	CU_ASSERT_EQUAL(variable_Data.time,600);
}

void MWO_UTC_008_004(void)
{
	button_Data.b_A = 0;
	button_Data.b_B = 1;
	variable_Data.time = 600;

	time_setting();
	
	CU_ASSERT_EQUAL(variable_Data.time,30);
}

void MWO_UTC_009_000(void) 
{
	variable_Data.c_value = 0;
	variable_Data.d_value = 0;
	
	menu_setting();

	CU_ASSERT_EQUAL(variable_Data.time, 0);
	CU_ASSERT_EQUAL(variable_Data.menu, "00 : MANUAL");
}

void MWO_UTC_009_001(void) 
{
	variable_Data.c_value = 0;
	variable_Data.d_value = 1;
	
	menu_setting();

	CU_ASSERT_EQUAL(variable_Data.time, 60);
	CU_ASSERT_EQUAL(variable_Data.menu, "01 : RICE CAKE");
}

void MWO_UTC_009_002(void) 
{
	variable_Data.c_value = 0;
	variable_Data.d_value = 2;
	
	menu_setting();

	CU_ASSERT_EQUAL(variable_Data.time, 90);
	CU_ASSERT_EQUAL(variable_Data.menu, "02 : RICE SOUP");
}

void MWO_UTC_009_003(void) 
{
	variable_Data.c_value = 0;
	variable_Data.d_value = 3;
	
	menu_setting();

	CU_ASSERT_EQUAL(variable_Data.time, 120);
	CU_ASSERT_EQUAL(variable_Data.menu, "03 : RICE");
}

void MWO_UTC_009_004(void) 
{
	variable_Data.c_value = 0;
	variable_Data.d_value = 4;
	
	menu_setting();

	CU_ASSERT_EQUAL(variable_Data.time, 300);
	CU_ASSERT_EQUAL(variable_Data.menu, "04 : SOUP");
}

void MWO_UTC_009_005(void) 
{
	variable_Data.c_value = 0;
	variable_Data.d_value = 5;
	
	menu_setting();

	CU_ASSERT_EQUAL(variable_Data.time, 120);
	CU_ASSERT_EQUAL(variable_Data.menu, "05 : PIZZA");
}

void MWO_UTC_010_000(void) 
{
	button_Data.b_A = 1;
	variable_Data.temp =0;

	temp_setting();

	CU_ASSERT_EQUAL(variable_Data.temp, 10);
}

void MWO_UTC_010_001(void) 
{
	button_Data.b_A = 1;
	variable_Data.temp = 80;

	temp_setting();

	CU_ASSERT_EQUAL(variable_Data.temp, 90);
}

void MWO_UTC_010_002(void) 
{
	button_Data.b_A = 1;
	variable_Data.temp = 90;

	temp_setting();

	CU_ASSERT_EQUAL(variable_Data.temp, 10);
}

void MWO_UTC_011_000(void) 
{
	button_Data.b_A = 0;
	button_Data.b_B = 1;
	variable_Data.temp = 0;

	temp_setting();

	CU_ASSERT_EQUAL(variable_Data.temp, 20);
}

void MWO_UTC_011_001(void) 
{
	button_Data.b_A = 0;
	button_Data.b_B = 1;
	variable_Data.temp = 70;

	temp_setting();

	CU_ASSERT_EQUAL(variable_Data.temp, 90);
}

void MWO_UTC_011_002(void) 
{
	button_Data.b_A = 0;
	button_Data.b_B = 1;
	variable_Data.temp = 80;

	temp_setting();

	CU_ASSERT_EQUAL(variable_Data.temp, 90);
}

void MWO_UTC_011_003(void) 
{
	button_Data.b_A = 0;
	button_Data.b_B = 1;
	variable_Data.temp = 90;

	temp_setting();

	CU_ASSERT_EQUAL(variable_Data.temp, 20);
}

void MWO_UTC_012_000(void) 
{
	variable_Data.d_value = 0;
	variable_Data.c_value = 0;

	mode_setting();

	CU_ASSERT_EQUAL(variable_Data.temp, 20);
	CU_ASSERT_EQUAL(variable_Data.mode, "TIME");

}

void MWO_UTC_012_001(void) 
{
	variable_Data.d_value = 0;
	variable_Data.c_value = 1;

	mode_setting();

	CU_ASSERT_EQUAL(variable_Data.time, 0);
	CU_ASSERT_EQUAL(variable_Data.mode, "TEMP");
}

void MWO_UTC_013_000(void)
{
	variable_Data.e_value = 1;
	variable_Data.c_value = 0;
	variable_Data.time = 10;

	start_cancel();

	CU_ASSERT_EQUAL(variable_Data.light, 1);
	CU_ASSERT_EQUAL(variable_Data.time, 9);
}
void MWO_UTC_013_001(void)
{
	variable_Data.e_value = 1;
	variable_Data.c_value = 0;
	variable_Data.time = 2;

	start_cancel();

	CU_ASSERT_EQUAL(variable_Data.light, 1);
	CU_ASSERT_EQUAL(variable_Data.e_value, 2);
}
void MWO_UTC_013_002(void)
{
	variable_Data.e_value = 0;

	start_cancel();

	CU_ASSERT_EQUAL(variable_Data.d_value, 0);
	CU_ASSERT_EQUAL(variable_Data.menu, "00 : MANUAL");
	CU_ASSERT_EQUAL(variable_Data.light, 0);
	CU_ASSERT_EQUAL(variable_Data.time, 0);
	CU_ASSERT_EQUAL(variable_Data.temp, 20);
	CU_ASSERT_EQUAL(variable_Data.temp_s, 20);
}
void MWO_UTC_014_000(void)
{ 
	variable_Data.e_value = 1;
	variable_Data.c_value = 1;
	variable_Data.check = 6;
	variable_Data.temp_s = 0;
	variable_Data.temp = 10;

	start_cancel();

	CU_ASSERT_EQUAL(variable_Data.temp_s, 10);
	CU_ASSERT_EQUAL(variable_Data.e_value, 2);
}
void MWO_UTC_014_001(void)
{
	variable_Data.e_value = 2;

	start_cancel();

	CU_ASSERT_EQUAL(variable_Data.d_value, 0);
	CU_ASSERT_EQUAL(variable_Data.menu, "00 : MANUAL");
	CU_ASSERT_EQUAL(variable_Data.light, 0);
	CU_ASSERT_EQUAL(variable_Data.time, 0);
	CU_ASSERT_EQUAL(variable_Data.temp, 20);
	CU_ASSERT_EQUAL(variable_Data.temp_s, 20);
	CU_ASSERT_EQUAL(variable_Data.sound, 1);
	CU_ASSERT_EQUAL(variable_Data.e_value, 0);
	CU_ASSERT_EQUAL(button_Data.b_A, 0);
	CU_ASSERT_EQUAL(button_Data.b_B, 0);
	CU_ASSERT_EQUAL(button_Data.b_D, 0);
	CU_ASSERT_EQUAL(button_Data.b_C, 0);
	CU_ASSERT_EQUAL(button_Data.b_D, 0);
	CU_ASSERT_EQUAL(button_Data.b_F, 0);
}
void MWO_UTC_015_000(void)
{ 
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	button_Data.b_A = 1;
	variable_Data.c_value = 0;
	variable_Data.d_value = 0;

	monitor_controller();

	CU_ASSERT_EQUAL(button_Data.b_A, 0);
}
void MWO_UTC_015_001(void)
{ 
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	button_Data.b_A = 1;
	variable_Data.c_value = 1;
	variable_Data.d_value = 0;

	monitor_controller();

	CU_ASSERT_EQUAL(button_Data.b_A, 0);
}
void MWO_UTC_016_000(void)
{ 
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	button_Data.b_B = 1;
	variable_Data.c_value = 0;
	variable_Data.d_value = 0;

	monitor_controller();

	CU_ASSERT_EQUAL(button_Data.b_B, 0);
}
void MWO_UTC_016_001(void)
{ 
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	button_Data.b_B= 1;
	variable_Data.c_value = 1;
	variable_Data.d_value = 0;

	monitor_controller();

	CU_ASSERT_EQUAL(button_Data.b_B, 0);
}
void MWO_UTC_017_000(void)
{ 
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	button_Data.b_C = 1;
	variable_Data.d_value = 0;

	monitor_controller();

	CU_ASSERT_EQUAL(button_Data.b_C, 0);
}
void MWO_UTC_018_000(void)
{ 
	variable_Data.e_value = 0;
	variable_Data.f_value = 0;
	button_Data.b_D = 1;
	variable_Data.c_value = 0;

	monitor_controller();

	CU_ASSERT_EQUAL(button_Data.b_C, 0);
}
void MWO_UTC_019_000(void)
{ 
	button_Data.b_E = 1;

	monitor_controller();

	CU_ASSERT_EQUAL(button_Data.b_E, 0);
}
void MWO_UTC_019_001(void)
{ 
	variable_Data.e_value = 1;

	monitor_controller();

	CU_ASSERT_EQUAL(button_Data.b_E, 0);
}
void MWO_UTC_019_002(void)
{ 
	variable_Data.e_value = 2;

	monitor_controller();

	CU_ASSERT_EQUAL(button_Data.b_E, 0);
}

int main()
{

	CU_pSuite MWO_UTC_000 = NULL;
	 CU_pSuite MWO_UTC_001 = NULL;
	 CU_pSuite MWO_UTC_002 = NULL;
	 CU_pSuite MWO_UTC_003 = NULL;
	 CU_pSuite MWO_UTC_004 = NULL;
	 CU_pSuite MWO_UTC_005 = NULL;
	 CU_pSuite MWO_UTC_006 = NULL;
	 CU_pSuite MWO_UTC_007 = NULL;
	 CU_pSuite MWO_UTC_008 = NULL;
	 CU_pSuite MWO_UTC_009 = NULL;
	 CU_pSuite MWO_UTC_010 = NULL;
	 CU_pSuite MWO_UTC_011 = NULL;
	 CU_pSuite MWO_UTC_012 = NULL;
	 CU_pSuite MWO_UTC_013 = NULL;
	 CU_pSuite MWO_UTC_014 = NULL;
	 CU_pSuite MWO_UTC_015 = NULL;
	 CU_pSuite MWO_UTC_016 = NULL;
	 CU_pSuite MWO_UTC_017 = NULL;
	 CU_pSuite MWO_UTC_018 = NULL;
	 CU_pSuite MWO_UTC_019 = NULL;

	 if(CUE_SUCCESS != CU_initialize_registry())
		return CU_get_error();

	 //ڽ  κ 

	 MWO_UTC_000 = CU_add_suite("Testing MWO_UTC_O00", NULL, NULL);	
	 if(NULL == MWO_UTC_000){
		 CU_cleanup_registry();
		return CU_get_error();
	 }
	 if( (NULL == CU_add_test(MWO_UTC_000, "MWO.UTC.000.000", MWO_UTC_000_000))
		 || (NULL == CU_add_test(MWO_UTC_000, "MWO.UTC.000.001", MWO_UTC_000_001)))
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }



	 MWO_UTC_001 = CU_add_suite("Testing MWO_UTC_O01", NULL, NULL);
	 if(NULL == MWO_UTC_001){
		 CU_cleanup_registry();
		return CU_get_error();
	 }
	 if( (NULL == CU_add_test(MWO_UTC_001, "MWO.UTC.001.000", MWO_UTC_001_000))
		 || (NULL == CU_add_test(MWO_UTC_001, "MWO.UTC.001.001", MWO_UTC_001_001)))
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }


	 MWO_UTC_002 = CU_add_suite("Testing MWO_UTC_O02", NULL, NULL);	
	 if(NULL == MWO_UTC_002){
		 CU_cleanup_registry();
		return CU_get_error();
	 }
	 if( (NULL == CU_add_test(MWO_UTC_002, "MWO.UTC.002.000", MWO_UTC_002_000))
		 || (NULL == CU_add_test(MWO_UTC_002, "MWO.UTC.002.001", MWO_UTC_002_001))
		 || (NULL == CU_add_test(MWO_UTC_002, "MWO.UTC.002.002", MWO_UTC_002_002))
	 	 || (NULL == CU_add_test(MWO_UTC_002, "MWO.UTC.002.003", MWO_UTC_002_003)))
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }

	 
	 MWO_UTC_003 = CU_add_suite("Testing MWO_UTC_O03", NULL, NULL);
	 if(NULL == MWO_UTC_003){
		 CU_cleanup_registry();
		return CU_get_error();
	 }
	 if( (NULL == CU_add_test(MWO_UTC_003, "MWO.UTC.003.000", MWO_UTC_003_000))
		 || (NULL == CU_add_test(MWO_UTC_003, "MWO.UTC.003.001", MWO_UTC_003_001)))
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }

	 
	 MWO_UTC_004 = CU_add_suite("Testing MWO_UTC_O04", NULL, NULL);
	 if(NULL == MWO_UTC_004){
		 CU_cleanup_registry();
		return CU_get_error();
	 }
	 if( (NULL == CU_add_test(MWO_UTC_004, "MWO.UTC.004.000", MWO_UTC_004_000)))
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }
	

	 //005
	 MWO_UTC_005 = CU_add_suite("Testing MWO_UTC_O05", NULL, NULL);
	
	 if(NULL == MWO_UTC_005){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if(NULL == CU_add_test(MWO_UTC_005, "MWO.UTC.005.000", MWO_UTC_005_000))
	 {
		 CU_cleanup_registry();
		 return CU_get_error();
	 }

	 //006
	 MWO_UTC_006 = CU_add_suite("Testing MWO_UTC_O06", NULL, NULL);
	
	 if(NULL == MWO_UTC_006){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if(NULL == CU_add_test(MWO_UTC_006, "MWO.UTC.006.000", MWO_UTC_006_000))
	 {
		 CU_cleanup_registry();
		 return CU_get_error();
	 }

	 //007
	 MWO_UTC_007 = CU_add_suite("Testing MWO_UTC_O07", NULL, NULL);
	
	 if(NULL == MWO_UTC_007){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if(NULL == CU_add_test(MWO_UTC_007, "MWO.UTC.007.000", MWO_UTC_007_000)
		 ||NULL == CU_add_test(MWO_UTC_007, "MWO.UTC.007.001", MWO_UTC_007_001)
		 ||NULL == CU_add_test(MWO_UTC_007, "MWO.UTC.007.002", MWO_UTC_007_002))
	 {
		 CU_cleanup_registry();
		 return CU_get_error();
	 }

	 //008
	 MWO_UTC_008 = CU_add_suite("Testing MWO_UTC_O08", NULL, NULL);
	
	 if(NULL == MWO_UTC_008){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if(NULL == CU_add_test(MWO_UTC_008, "MWO.UTC.008.000", MWO_UTC_008_000)
		 ||NULL == CU_add_test(MWO_UTC_008, "MWO.UTC.008.001", MWO_UTC_008_001)
		 ||NULL == CU_add_test(MWO_UTC_008, "MWO.UTC.008.002", MWO_UTC_008_002)
		 ||NULL == CU_add_test(MWO_UTC_008, "MWO.UTC.008.003", MWO_UTC_008_003)
		 ||NULL == CU_add_test(MWO_UTC_008, "MWO.UTC.008.004", MWO_UTC_008_004))
	 {
		 CU_cleanup_registry();
		 return CU_get_error();
	 }

	 MWO_UTC_009 = CU_add_suite("Testing MWO_UTC_O09", NULL, NULL);
	
	 if(NULL == MWO_UTC_009){
		 CU_cleanup_registry();
		return CU_get_error();
	 }
	 if(NULL == CU_add_test(MWO_UTC_009,"MWO.UTC.009.000",MWO_UTC_009_000)
		 ||NULL == CU_add_test(MWO_UTC_009,"MWO.UTC.009.001",MWO_UTC_009_001)
		 ||NULL == CU_add_test(MWO_UTC_009,"MWO.UTC.009.002",MWO_UTC_009_002)
		 ||NULL == CU_add_test(MWO_UTC_009,"MWO.UTC.009.003",MWO_UTC_009_003)
		 ||NULL == CU_add_test(MWO_UTC_009,"MWO.UTC.009.004",MWO_UTC_009_004)
		 ||NULL == CU_add_test(MWO_UTC_009,"MWO.UTC.009.005",MWO_UTC_009_005))
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }

	 MWO_UTC_010 = CU_add_suite("Testing MWO_UTC_O10", NULL, NULL);
	
	 if(NULL == MWO_UTC_010){
		 CU_cleanup_registry();
		return CU_get_error();
	 }
	 if(NULL == CU_add_test(MWO_UTC_010,"MWO.UTC.010.000",MWO_UTC_010_000)
		 ||NULL == CU_add_test(MWO_UTC_010,"MWO.UTC.010.001",MWO_UTC_010_001)
		 ||NULL == CU_add_test(MWO_UTC_010,"MWO.UTC.010.002",MWO_UTC_010_002))
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }

	 MWO_UTC_011 = CU_add_suite("Testing MWO_UTC_O11", NULL, NULL);
	
	 if(NULL == MWO_UTC_011){
		 CU_cleanup_registry();
		return CU_get_error();
	 }
	 if(NULL == CU_add_test(MWO_UTC_011,"MWO.UTC.011.000",MWO_UTC_011_000)
		 ||NULL == CU_add_test(MWO_UTC_011,"MWO.UTC.011.001",MWO_UTC_011_001)
		 ||NULL == CU_add_test(MWO_UTC_011,"MWO.UTC.011.002",MWO_UTC_011_002)
		 ||NULL == CU_add_test(MWO_UTC_011,"MWO.UTC.011.003",MWO_UTC_011_003))
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }

	  MWO_UTC_012 = CU_add_suite("Testing MWO_UTC_O12", NULL, NULL);
	
	 if(NULL == MWO_UTC_012){
		 CU_cleanup_registry();
		return CU_get_error();
	 }
	 if(NULL == CU_add_test(MWO_UTC_012,"MWO.UTC.012.000",MWO_UTC_012_000)
		 ||NULL == CU_add_test(MWO_UTC_012,"MWO.UTC.012.001",MWO_UTC_012_001))
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }


	 MWO_UTC_013 = CU_add_suite("Testing MWO_UTC_O13", NULL, NULL);
	 MWO_UTC_014 = CU_add_suite("Testing MWO_UTC_O14", NULL, NULL);
	 MWO_UTC_015 = CU_add_suite("Testing MWO_UTC_O15", NULL, NULL);
	 MWO_UTC_016 = CU_add_suite("Testing MWO_UTC_O16", NULL, NULL);
	 MWO_UTC_017 = CU_add_suite("Testing MWO_UTC_O17", NULL, NULL);
	 MWO_UTC_018 = CU_add_suite("Testing MWO_UTC_O18", NULL, NULL);
	 MWO_UTC_019 = CU_add_suite("Testing MWO_UTC_O19", NULL, NULL);
	
	 if(NULL == MWO_UTC_013){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if ( (NULL == CU_add_test(MWO_UTC_013, "MWO.UTC.013.000", MWO_UTC_013_000))
		 || ( NULL == CU_add_test(MWO_UTC_013, "MWO.UTC.013.001", MWO_UTC_013_001))
		 || ( NULL == CU_add_test(MWO_UTC_013, "MWO.UTC.013.002", MWO_UTC_013_002)) )
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }
	  if(NULL == MWO_UTC_014){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if ( (NULL == CU_add_test(MWO_UTC_014, "MWO.UTC.014.000", MWO_UTC_014_000))
		 || ( NULL == CU_add_test(MWO_UTC_014, "MWO.UTC.014.001", MWO_UTC_014_001)) )
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }

	  if(NULL == MWO_UTC_015){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if ( (NULL == CU_add_test(MWO_UTC_015, "MWO.UTC.015.000", MWO_UTC_015_000))
		 || ( NULL == CU_add_test(MWO_UTC_015, "MWO.UTC.015.001", MWO_UTC_015_001)) )
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }

	   if(NULL == MWO_UTC_016){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if ( (NULL == CU_add_test(MWO_UTC_016, "MWO.UTC.016.000", MWO_UTC_016_000))
		 || ( NULL == CU_add_test(MWO_UTC_016, "MWO.UTC.016.001", MWO_UTC_016_001)) )
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }
	   if(NULL == MWO_UTC_017){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if ( (NULL == CU_add_test(MWO_UTC_017, "MWO.UTC.017.000", MWO_UTC_017_000)) )
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }
	 if(NULL == MWO_UTC_018){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if ( (NULL == CU_add_test(MWO_UTC_018, "MWO.UTC.018.000", MWO_UTC_018_000)) )
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }
	 if(NULL == MWO_UTC_019){
		 CU_cleanup_registry();
		return CU_get_error();
	 }

	 if ( (NULL == CU_add_test(MWO_UTC_019, "MWO.UTC.019.000", MWO_UTC_019_000))
		 || ( NULL == CU_add_test(MWO_UTC_019, "MWO.UTC.019.001", MWO_UTC_019_001))
		 || ( NULL == CU_add_test(MWO_UTC_019, "MWO.UTC.019.002", MWO_UTC_019_002)) )
	 {
		CU_cleanup_registry();
		return CU_get_error();
	 }

	 CU_basic_set_mode(CU_BRM_VERBOSE);
	 CU_basic_run_tests();

	 CU_cleanup_registry();

	 return CU_get_error();
}